"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const constants_1 = require("next-server/constants");
const path_1 = require("path");
const require_1 = require("./require");
function interopDefault(mod) {
    return mod.default || mod;
}
async function loadComponents(distDir, buildId, pathname) {
    const documentPath = path_1.join(distDir, constants_1.SERVER_DIRECTORY, constants_1.CLIENT_STATIC_FILES_PATH, buildId, 'pages', '_document');
    const appPath = path_1.join(distDir, constants_1.SERVER_DIRECTORY, constants_1.CLIENT_STATIC_FILES_PATH, buildId, 'pages', '_app');
    const [buildManifest, reactLoadableManifest, Component, Document, App] = await Promise.all([
        require(path_1.join(distDir, constants_1.BUILD_MANIFEST)),
        require(path_1.join(distDir, constants_1.REACT_LOADABLE_MANIFEST)),
        interopDefault(require_1.requirePage(pathname, distDir)),
        interopDefault(require(documentPath)),
        interopDefault(require(appPath)),
    ]);
    return { buildManifest, reactLoadableManifest, Component, Document, App };
}
exports.loadComponents = loadComponents;
