"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
async function optimize(html, { amphtml, query }) {
    let ampOptimizer;
    try {
        ampOptimizer = require('amp-toolbox-optimizer');
    }
    catch (_) {
        return html;
    }
    const validAmp = Boolean(amphtml && query && query.amp);
    //  Examples below
    //
    //  pages/foo.js
    //  pages/foo.amp.js
    //  pages/bar.amp.js
    //
    //  /foo => traditional
    //  /foo?amp=1 => clean AMP
    //  /bar => dirty amp
    //  /bar?amp=1 => clean AMP
    ampOptimizer.setConfig({ validAmp });
    html = await ampOptimizer.transformHtml(html);
    return html;
}
exports.default = optimize;
